package org.gcube.application.geoportal.service.ws;

import org.gcube.application.geoportal.service.TokenSetter;
import org.gcube.common.storagehub.client.dsl.FolderContainer;
import org.gcube.common.storagehub.client.dsl.StorageHubClient;
import org.gcube.common.storagehub.model.exceptions.StorageHubException;
import org.gcube.common.storagehub.model.items.*;

public class DescribeWSFolder {


    static StorageHubClient shc =null;

    public static void main(String[] args) throws StorageHubException {
        String context="/gcube/devsec/devVRE";
        String folderID="28774602-6423-4870-9afb-f8f4b585b438";
        Boolean recursive = true;

        TokenSetter.set(context);
        shc= new StorageHubClient();
        FolderContainer folder=shc.open(folderID).asFolder();

        FolderItem item=folder.get();
            System.out.print("PATH : "+item.getPath()+"\tHIDDEN : "+item.isHidden()+"\tDescription : "+item.getDescription());

        System.out.println("Listing... ");
        print(folder,"");
//        for (Item i :  folder.list().includeHidden().getItems()) {
//            System.out.println("name:" + i.getName() + " type " + i.getPrimaryType());
//
////            System.out.println("name:" + i.getName() + " is a File?: " + (i instanceof AbstractFileItem));
////            System.out.println("name:" + i.getName() + " is a folder?: " + (i instanceof FolderItem));
////            System.out.println("name:" + i.getName() + " is a shared folder?: " + (i instanceof SharedFolder));
////            System.out.println("name:" + i.getName() + " is a VRE folder?: " + (i instanceof VreFolder));
//        }
    }

    private static final void print(FolderContainer folder,String pad) throws StorageHubException {
        for (Item i :  folder.list().includeHidden().getItems()) {
            System.out.println(pad+"name:" + i.getName() + " type " + i.getPrimaryType());
            if(i instanceof FolderItem){
                print(shc.open(i.getId()).asFolder(),pad+"\t");
            }
        }
    }
}
