package org.gcube.application.geoportal.common;

import lombok.extern.slf4j.Slf4j;
import org.gcube.application.geoportal.common.utils.Files;
import org.junit.Test;

import java.io.File;

import static org.junit.Assert.assertTrue;

@Slf4j
public class FilesTests {

    @Test
    public void testNames(){
       for(String name : new File("../test-data/concessioni").list()){
           if(name.contains(".")) {
               String originalExtension = name.substring(name.indexOf("."));
               String obtained = Files.fixFilename(name);
               log.info(name + "->" + obtained + "[" + originalExtension + "]");
               assertTrue(obtained.endsWith(originalExtension));
           }
       }
    }

}
