package org.gcube.application.cms.usecases;

import org.gcube.application.cms.tests.TokenSetter;
import org.gcube.application.geoportal.client.legacy.ConcessioniManagerI;
import org.gcube.application.geoportal.common.model.legacy.Concessione;
import org.gcube.application.geoportal.common.rest.MongoConcessioni;


import static org.gcube.application.geoportal.client.GeoportalAbstractPlugin.mongoConcessioni;

public class RepublishSingle {

    public static void main(String[] args) throws Exception {
        TokenSetter.set("/gcube/devsec/devVRE");

        String id="6138c3a002ad3d1f0cd659f4";

        MongoConcessioni manager=mongoConcessioni().build();

        manager.unPublish(id);

        System.out.println("Going to publish... ");
        Concessione c=manager.publish(id);

        System.out.println("Result is "+c);
        System.out.println("REPORT STATUST : "+c.getReport().getStatus());
    }
}
